import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Den Geistern sollte es ermglicht sein, sich frei zu bewegen. Ursprnglich wollten wir sie so programieren, dasses ihnen ermglicht is, Pacman ausfindig
 * zu machen, und ihn zu suchen.
 * Leider haben wir es nicht geschafft, sie soweit zu programmieren und somit bleibt dieses Feature aus.
 */
public class Ghosts  extends Actor
{
    public final static int NORD = 0;
    public final static int OST = 1;
    public final static int SUED = 2;
    public final static int WEST = 3;

    protected int direction;

    /**
     * Act wird immer wieder aufgerufen. Daher haben wir die Knstliche intelligens (KI) in eine Calculate Methode gepackt. HIerbei wird mit einer 25% Chance
     * die Richtung, in die sich die Ghosts bewegen knnen generiert. Es gibt verschiedene If befragungen, die auch die Flle zugeschnitten sind. Es wird
     * gefragt, wo eine Wall ist, oder auch nicht. 
     */
    public void act() 
    {
      calculateKIMove();  
    }  
    
    public Ghosts()
    {
        direction = NORD;
    }
  
    private void calculateKIMove()
    {
        int x = getX();
        int y = getY();
        
        boolean WallLeft = true;
        boolean WallRight = true;
        boolean WallFront = true;
        
        switch (direction) {
            case NORD:
                WallLeft  = isWall(-1,0);
                WallRight = isWall(+1,0);
                WallFront = isWall(0,-1);
                break;
            case SUED:
                WallLeft  = isWall(+1,0);
                WallRight = isWall(-1,0);
                WallFront = isWall(0,+1);
                break;
            case OST:
                WallLeft  = isWall(0,-1);
                WallRight = isWall(0,+1);
                WallFront = isWall(+1,0);
                break;
            case WEST:
                WallLeft  = isWall(0,+1);
                WallRight = isWall(0,-1);
                WallFront = isWall(-1,0);
                break;
        } 
        
        if (WallLeft && WallRight && WallFront)
        {
            moveTurn();
        }
        else if (WallFront)
        {
            moveTurn();
        }
        else if ( (! WallRight) || (! WallLeft) )
        {
            if (Greenfoot.getRandomNumber(4) == 1)
            {
                moveTurn();
            }
            else
            {
                moveForward();
            }
        }
        else
        {
            moveForward();
        }
    }
    
    public boolean isWall(int X, int Y) 
    {
        boolean isWall = (getOneObjectAtOffset(X, Y, Walls.class) != null);
        return (getOneObjectAtOffset(X, Y, Walls.class) != null);
    }    
    
    private void moveForward()
    {
        int newX=getX();
        int newY=getY();
        int oldX=getX();
        int oldY=getY();

        switch (direction) {
            case NORD:
                newY -= 1;
                break;
            case SUED:
                newY += 1;
                break;
            case OST:
                if (oldX==18)
                {newX = 0;}
                else {newX += 1;}
                break;
            case WEST:
                if (oldX==0)
                {newX = 18;}
                else {newX -= 1;}
                break;
        }
        setLocation(newX,newY);
    }
    
    private void moveTurn()
    {
        int newX=getX();
        int newY=getY();
        int oldX=getX();
        int oldY=getY();
        
        boolean WallLeft = true;
        boolean WallRight = true;
        
        switch (direction) {
            case NORD:
                WallLeft  = isWall(-1,0);
                WallRight = isWall(+1,0);
                break;
            case SUED:
                WallLeft  = isWall(+1,0);
                WallRight = isWall(-1,0);
                break;
            case OST:
                WallLeft  = isWall(0,-1);
                WallRight = isWall(0,+1);
                break;
            case WEST:
                WallLeft  = isWall(0,+1);
                WallRight = isWall(0,-1);
                break;
        }   
        
        if (! WallLeft && WallRight) // Links abbiegen
        {
            switch (direction) {
                case NORD:
                    newX += -1;
                    newY += 0;
                    direction = WEST;
                    break;
                case SUED:
                    newX += +1;
                    newY += 0;
                    direction = OST;
                    break;
                case OST:
                    newX += 0;
                    newY += -1;
                    direction = NORD;
                    break;
                case WEST:
                    newX += 0;
                    newY += +1;
                    direction = SUED;
                    break;
            }  
        }
        else if (! WallRight && WallLeft) // Rechts abbiegen
        {
            switch (direction) {
                case NORD:
                    newX += +1;
                    newY += 0;
                    direction = OST;
                    break;
                case SUED:
                    newX += -1;
                    newY += 0;
                    direction = WEST;
                    break;
                case OST:
                    newX += 0;
                    newY += +1;
                    direction = SUED;
                    break;
                case WEST:
                    newX += 0;
                    newY += -1;
                    direction = NORD;
                    break;
            } 
        }
        else if (!(WallLeft && WallRight)) // zufllig abbiegen
        {
            int tempVal = Greenfoot.getRandomNumber(2)*2 -1;
            switch (direction) {
                case NORD:
                    newX += +1*tempVal;
                    newY += 0;
                    break;
                case SUED:
                    newX += -1*tempVal;
                    newY += 0;
                    break;
                case OST:
                    newX += 0;
                    newY += +1*tempVal;
                    break;
                case WEST:
                    newX += 0;
                    newY += -1*tempVal;
                }
            direction += tempVal;
            if (direction == 4) {direction = 0;}
            if (direction == -1) {direction = 3;}
        }
        else if (WallLeft && WallRight) // umkehren
        {
            switch (direction) {
                case NORD:
                    newX += 0;
                    newY += +1;
                    direction = SUED;
                    break;
                case SUED:
                    newX += 0;
                    newY += -1;
                    direction = NORD;
                    break;
                case OST:
                    newX += -1;
                    newY += 0;
                    direction = WEST;
                    break;
                case WEST:
                    newX += +1;
                    newY += 0;
                    direction = OST;
                    break;
            } 
        }
        
        setLocation(newX,newY);
    }
}
