import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Pacman ist der Held des Spieles, und der zu lenkende Actor. Er muss alle Points aufessen
 * und darf nicht von den Ghost's gegessen werden.
 * 
 */
public class Pacman extends Actor 
{   public final static int NORD = 0;
    public final static int OST = 1;
    public final static int SUED = 2;
    public final static int WEST = 3;
    private int blickrichtung;

    public Pacman()
    {
        blickrichtung = OST;
    }

    /**
     * Da act eine immerwieder aufgerufene Methode ist,
     * soll sich Pacman mithilfe von "moveForward()" und "pressKey()" bewegen knnnen.
     * 
     */

    public void act() 
    {
        pressKey();
        moveForward();
        essen();
    }

    /** Public void moveForward ist die Definition fr die durchgehende Vorwrtsbewegung von Pacman. Sie ist in Flle
     * aufgeteilt und beinhaltet die Blickrichtung.
     * 
     */
    public void moveForward() {
        int newX=getX();
        int newY=getY();
        int oldX=getX();
        int oldY=getY();

        switch (blickrichtung) {
            case NORD:
            if (isWall(0, -1)) {}
            else {newY -= 1;
            }
            break;
            case SUED:
            if (isWall(0, +1)) {}
            else {newY += 1;
            }
            break;
            case OST:
            if (isWall(+1, 0)) {}
            else if (oldX==18)
            {newX = 0;}
            else {newX += 1;
            }
            break;
            case WEST:
            if (isWall(-1, 0)) {}
            else if (oldX==0)
            {newX = 18;}
            else {newX -= 1;
            }
            break;
        }

        /**
         * Sobald Pacman einen Ghost streift oder durchluft stirbt er. Dass heit, das Spiel muss gestoppt werden und ein Game Over Schild angezeigt werden
         * dieses wird mithilfe von AddObject und Greenfoot.stop aufgerufen.
         */
        if (getOneObjectAtOffset(0, 0, Ghost1.class) != null || 
        getOneObjectAtOffset(0, 0, Ghost2.class) != null || 
        getOneObjectAtOffset(0, 0, Ghost3.class) != null || 
        getOneObjectAtOffset(0, 0, Ghost4.class) != null  )
        {

            Greenfoot.stop(); // GameOver
            getWorld().addObject ( new GameOver(), 9, 16);
            getWorld().addObject ( new YourPoints(), 9, 28);
        }        

        setLocation(newX,newY);

        if (getOneObjectAtOffset(0, 0, Ghost1.class) != null || 
        getOneObjectAtOffset(0, 0, Ghost2.class) != null || 
        getOneObjectAtOffset(0, 0, Ghost3.class) != null || 
        getOneObjectAtOffset(0, 0, Ghost4.class) != null  )
        {

            Greenfoot.stop(); // GameOver
            getWorld().addObject ( new GameOver(), 9, 16);
            getWorld().addObject ( new YourPoints(), 9, 28);

        }
    }

    
        /**
         * Pacman wird mithilfe von den Pfeiltasten gesteuert, mithilfe einer Fallaufteilung kann aus jeder beliebigen Blickrichtung Pacman abbiegen
         * oder umdrehen.
         */
    private void pressKey() {
        if (Greenfoot.isKeyDown("left"))
        {
            blickrichtung = WEST;
            setRotation(-180);
        }
        if (Greenfoot.isKeyDown("right"))
        {
            blickrichtung = OST;
            setRotation(0);
        }
        if (Greenfoot.isKeyDown("up"))
        {
            blickrichtung = NORD;
            setRotation(-90);
        }
        if (Greenfoot.isKeyDown("down"))
        {
            blickrichtung = SUED;
            setRotation(90);
        }
    }
    
    /**
     * Public boolean isWall lsst Pacman nicht durch Wnde laufen.
     */
    public boolean isWall(int X, int Y) {

        boolean isWall = (getOneObjectAtOffset(X, Y, Walls.class) != null);
        return (getOneObjectAtOffset(X, Y, Walls.class) != null);
    }

    
    /**
     * Public void essen ermglicht die Erhhung des Counters. Sobald Pacman ber einem der Points ist, wird dieser "aufgefressen" bzw. removed.
     * Dabei wird der Counter um 10 nach oben versetzt.
     */
    public void essen() {
        if (getOneIntersectingObject (Point.class ) != null){
            getWorld().removeObject(getOneIntersectingObject (Point.class));
            ((Pacworld)getWorld()).setPunkte(((Pacworld)getWorld()).getPunkte()+10);
        }               
    }

}
