import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Die Pacworld ist eine von uns selbsterschaffene mit Wnden und Punkten versehene Welt, in der sich 
 * Pacman bewegen kann. Sie hat eine gre von 160/160 Zellen.
 * 
 * Autoren: Mario Ntzel und Alexander Krestyn
 * Diese Grundversion des Spiels wurde im Februar 2011 programmiert und erfunden.
 */
public class Pacworld  extends World
{

    private int Punkte;  
    private Counter myCounter;
    GreenfootSound Musik = new GreenfootSound("Musik.mp3");

    /**
     * Mithilfe einer Rangordnung konnten wir die Images bereinander Lagern. Leider gab es ein Problem
     * mit den "Points", die selbst nach Anordnung noch ber den Ghosts zu sehen sind.
     * 
     */
    public Pacworld()
    {    
        // Create a new world with 19x29 cells with a cell size of 20x20 pixels.
        super(19, 29, 20); 

        setPaintOrder(Counter.class,
                      PacManLogo.class,
                      Walls.class,
                      Ghost1.class,
                      Ghost2.class,
                      Ghost3.class,
                      Ghost4.class,
                      GameOver.class,
                      Pacman.class,
                      Point.class);

        Counter myCounter= new Counter(this);
        addObject(myCounter,9,28);
        setPaintOrder(Counter.class);
        Greenfoot.playSound("Musik.mp3");

        //Pacman erstellen
        addObject ( new Pacman(), 9, 18);

        //Ghost erstellen
        addObject ( new Ghost1(), 8, 16);
        addObject ( new Ghost2(), 9, 16);
        addObject ( new Ghost3(), 10, 16);
        addObject ( new Ghost4(), 9, 16);
        addObject ( new Ghost1(), 9, 16);

        //Walls erstellen
        addObject ( new Wall4(), 8, 15);
        addObject ( new Wall1(), 8, 17);
        addObject ( new Wall8(), 7, 15);
        addObject ( new Wall9(), 7, 17);
        addObject ( new Wall2(), 7, 16);
        addObject ( new Wall6(), 10, 15);
        addObject ( new Wall1(), 10, 17);
        addObject ( new Wall7(), 11, 15);
        addObject ( new Wall2(), 11, 16);
        addObject ( new Wall10(), 11, 17);
        addObject ( new Wall1(), 9, 17);

        addObject ( new Wall6(), 7, 19);
        addObject ( new Wall1(), 8, 19);
        addObject ( new Wall13(), 9, 19);
        addObject ( new Wall1(), 10, 19);
        addObject ( new Wall4(), 11, 19);
        addObject ( new Wall2(), 9, 20);
        addObject ( new Wall5(), 9, 21);

        addObject ( new Wall3(), 5, 17);
        addObject ( new Wall2(), 5, 18);
        addObject ( new Wall5(), 5, 19);

        addObject ( new Wall3(), 13, 17);
        addObject ( new Wall2(), 13, 18);
        addObject ( new Wall5(), 13, 19);

        addObject ( new Wall5(), 5, 15);
        addObject ( new Wall2(), 5, 14);
        addObject ( new Wall12(), 5, 13);
        addObject ( new Wall2(), 5, 12);
        addObject ( new Wall3(), 5, 11);
        addObject ( new Wall1(), 6, 13);
        addObject ( new Wall4(), 7, 13);

        addObject ( new Wall5(), 13, 15);
        addObject ( new Wall2(), 13, 14);
        addObject ( new Wall14(), 13, 13);
        addObject ( new Wall2(), 13, 12); 
        addObject ( new Wall3(), 13, 11); 
        addObject ( new Wall1(), 12, 13);
        addObject ( new Wall6(), 11, 13);

        addObject ( new Wall6(), 7, 11);
        addObject ( new Wall1(), 8, 11);
        addObject ( new Wall13(), 9, 11);
        addObject ( new Wall1(), 10, 11);
        addObject ( new Wall4(), 11, 11);
        addObject ( new Wall2(), 9, 12);
        addObject ( new Wall5(), 9, 13);

        addObject ( new Wall6(), 7, 23);
        addObject ( new Wall1(), 8, 23);
        addObject ( new Wall13(), 9, 23);
        addObject ( new Wall1(), 10, 23);
        addObject ( new Wall4(), 11, 23);
        addObject ( new Wall2(), 9, 24);
        addObject ( new Wall5(), 9, 25);

        addObject ( new Wall6(), 5, 21);
        addObject ( new Wall1(), 6, 21);
        addObject ( new Wall4(), 7, 21);

        addObject ( new Wall6(), 11, 21);
        addObject ( new Wall1(), 12, 21);
        addObject ( new Wall4(), 13, 21);

        addObject ( new Wall3(), 5, 23);
        addObject ( new Wall2(), 5, 24);
        addObject ( new Wall11(), 5, 25);
        addObject ( new Wall1(), 6, 25);
        addObject ( new Wall1(), 4, 25);
        addObject ( new Wall1(), 3, 25);
        addObject ( new Wall6(), 2, 25);
        addObject ( new Wall4(), 7, 25);

        addObject ( new Wall3(), 13, 23);
        addObject ( new Wall2(), 13, 24);
        addObject ( new Wall11(), 13, 25);
        addObject ( new Wall1(), 12, 25);
        addObject ( new Wall1(), 14, 25);
        addObject ( new Wall1(), 15, 25);
        addObject ( new Wall4(), 16, 25);
        addObject ( new Wall6(), 11, 25);

        addObject ( new Wall5(), 3, 23);
        addObject ( new Wall2(), 3, 22);
        addObject ( new Wall7(), 3, 21);
        addObject ( new Wall6(), 2, 21);

        addObject ( new Wall5(), 15, 23);
        addObject ( new Wall2(), 15, 22);
        addObject ( new Wall8(), 15, 21);
        addObject ( new Wall4(), 16, 21);

        addObject ( new Wall5(), 9, 9);
        addObject ( new Wall2(), 9, 8);
        addObject ( new Wall2(), 9, 7);

        addObject ( new Wall2(), 0, 26);
        addObject ( new Wall2(), 0, 25);
        addObject ( new Wall2(), 0, 24);
        addObject ( new Wall12(), 0, 23);
        addObject ( new Wall2(), 0, 22);
        addObject ( new Wall2(), 0, 21);
        addObject ( new Wall2(), 0, 20);

        addObject ( new Wall2(), 18, 26);
        addObject ( new Wall2(), 18, 25);
        addObject ( new Wall2(), 18, 24);
        addObject ( new Wall14(), 18, 23);
        addObject ( new Wall2(), 18, 22);
        addObject ( new Wall2(), 18, 21);
        addObject ( new Wall2(), 18, 20);

        addObject ( new Wall8(), 0, 19);
        addObject ( new Wall1(), 1, 19);
        addObject ( new Wall1(), 2, 19);
        addObject ( new Wall10(), 3, 19);

        addObject ( new Wall9(), 15, 19);
        addObject ( new Wall1(), 16, 19);
        addObject ( new Wall1(), 17, 19);
        addObject ( new Wall7(), 18, 19);

        addObject ( new Wall4(), 1, 23);

        addObject ( new Wall6(), 17, 23);

        addObject ( new Wall2(), 3, 18);
        addObject ( new Wall7(), 3, 17);
        addObject ( new Wall1(), 2, 17);
        addObject ( new Wall1(), 1, 17);
        addObject ( new Wall1(), 0, 17);

        addObject ( new Wall2(), 15, 18);
        addObject ( new Wall8(), 15, 17);
        addObject ( new Wall1(), 16, 17);
        addObject ( new Wall1(), 17, 17);
        addObject ( new Wall1(), 18, 17);

        addObject ( new Wall2(), 3, 14);
        addObject ( new Wall10(), 3, 15);
        addObject ( new Wall1(), 2, 15);
        addObject ( new Wall1(), 1, 15);
        addObject ( new Wall1(), 0, 15);

        addObject ( new Wall2(), 15, 14);
        addObject ( new Wall9(), 15, 15);
        addObject ( new Wall1(), 16, 15);
        addObject ( new Wall1(), 17, 15);
        addObject ( new Wall1(), 18, 15);

        addObject ( new Wall7(), 3, 13);
        addObject ( new Wall1(), 2, 13);
        addObject ( new Wall1(), 1, 13);
        addObject ( new Wall9(), 0, 13);

        addObject ( new Wall8(), 15, 13);
        addObject ( new Wall1(), 16, 13);
        addObject ( new Wall1(), 17, 13);
        addObject ( new Wall10(), 18, 13);

        addObject ( new Wall2(), 0, 12);
        addObject ( new Wall2(), 0, 11);
        addObject ( new Wall2(), 0, 10);
        addObject ( new Wall2(), 0, 9);
        addObject ( new Wall2(), 0, 8);
        addObject ( new Wall2(), 0, 7);

        addObject ( new Wall2(), 18, 12);
        addObject ( new Wall2(), 18, 11);
        addObject ( new Wall2(), 18, 10);
        addObject ( new Wall2(), 18, 9);
        addObject ( new Wall2(), 18, 8);
        addObject ( new Wall2(), 18, 7);

        addObject ( new Wall6(), 2, 11);
        addObject ( new Wall4(), 3, 11);        

        addObject ( new Wall6(), 15, 11);
        addObject ( new Wall4(), 16, 11);        

        addObject ( new Wall9(), 2, 9);
        addObject ( new Wall10(), 3, 9);        
        addObject ( new Wall8(), 2, 8);
        addObject ( new Wall7(), 3, 8);  

        addObject ( new Wall9(), 15, 9);
        addObject ( new Wall10(), 16, 9);        
        addObject ( new Wall8(), 15, 8);
        addObject ( new Wall7(), 16, 8);  

        addObject ( new Wall9(), 5, 9);
        addObject ( new Wall1(), 6, 9); 
        addObject ( new Wall10(), 7, 9);
        addObject ( new Wall8(), 5, 8);
        addObject ( new Wall1(), 6, 8);
        addObject ( new Wall7(), 7, 8);

        addObject ( new Wall9(), 11, 9);
        addObject ( new Wall1(), 12, 9); 
        addObject ( new Wall10(), 13, 9);
        addObject ( new Wall8(), 11, 8);
        addObject ( new Wall1(), 12, 8);
        addObject ( new Wall7(), 13, 8);

        addObject ( new Wall9(), 0, 27);
        addObject ( new Wall1(), 1, 27);
        addObject ( new Wall1(), 2, 27);
        addObject ( new Wall1(), 3, 27);
        addObject ( new Wall1(), 4, 27);
        addObject ( new Wall1(), 5, 27);
        addObject ( new Wall1(), 6, 27);
        addObject ( new Wall1(), 7, 27);
        addObject ( new Wall1(), 8, 27);
        addObject ( new Wall1(), 9, 27);
        addObject ( new Wall1(), 10, 27);
        addObject ( new Wall1(), 11, 27);
        addObject ( new Wall1(), 12, 27);
        addObject ( new Wall1(), 13, 27);
        addObject ( new Wall1(), 14, 27);
        addObject ( new Wall1(), 15, 27);
        addObject ( new Wall1(), 16, 27);
        addObject ( new Wall1(), 17, 27);
        addObject ( new Wall10(), 18, 27);

        addObject ( new Wall8(), 0, 6);
        addObject ( new Wall1(), 1, 6);
        addObject ( new Wall1(), 2, 6);
        addObject ( new Wall1(), 3, 6);
        addObject ( new Wall1(), 4, 6);
        addObject ( new Wall1(), 5, 6);
        addObject ( new Wall1(), 6, 6);
        addObject ( new Wall1(), 7, 6);
        addObject ( new Wall1(), 8, 6);
        addObject ( new Wall13(), 9, 6);
        addObject ( new Wall1(), 10, 6);
        addObject ( new Wall1(), 11, 6);
        addObject ( new Wall1(), 12, 6);
        addObject ( new Wall1(), 13, 6);
        addObject ( new Wall1(), 14, 6);
        addObject ( new Wall1(), 15, 6);
        addObject ( new Wall1(), 16, 6);
        addObject ( new Wall1(), 17, 6);
        addObject ( new Wall7(), 18, 6);

        // Punkte setzen

        // erste Reihe:
        addObject ( new Point(), 1, 7);
        addObject ( new Point(), 2, 7);

        addObject ( new Point(), 3, 7);
        addObject ( new Point(), 4, 7);
        addObject ( new Point(), 5, 7);
        addObject ( new Point(), 6, 7);
        addObject ( new Point(), 7, 7);
        addObject ( new Point(), 8, 7);
        addObject ( new Point(), 10, 7);
        addObject ( new Point(), 11, 7);
        addObject ( new Point(), 12, 7);
        addObject ( new Point(), 13, 7);
        addObject ( new Point(), 14, 7);
        addObject ( new Point(), 15, 7);
        addObject ( new Point(), 16, 7);
        addObject ( new Point(), 17, 7);
        // zweite Reihe:
        addObject ( new Point(), 1, 8);
        addObject ( new Point(), 4, 8);
        addObject ( new Point(), 8, 8);
        addObject ( new Point(), 10, 8);
        addObject ( new Point(), 14, 8);
        addObject ( new Point(), 17, 8);
        // dritte Reihe:
        addObject ( new Point(), 1, 9);
        addObject ( new Point(), 4, 9);
        addObject ( new Point(), 8, 9);
        addObject ( new Point(), 10, 9);
        addObject ( new Point(), 14, 9);
        addObject ( new Point(), 17, 9);
        // vierte Reihe:
        addObject ( new Point(), 1, 10);
        addObject ( new Point(), 2, 10);
        addObject ( new Point(), 3, 10);
        addObject ( new Point(), 4, 10);
        addObject ( new Point(), 5, 10);
        addObject ( new Point(), 6, 10);
        addObject ( new Point(), 7, 10);
        addObject ( new Point(), 8, 10);
        addObject ( new Point(), 9, 10);
        addObject ( new Point(), 10, 10);
        addObject ( new Point(), 11, 10);
        addObject ( new Point(), 12, 10);
        addObject ( new Point(), 13, 10);
        addObject ( new Point(), 14, 10);
        addObject ( new Point(), 15, 10);
        addObject ( new Point(), 16, 10);
        addObject ( new Point(), 17, 10);
        // fnfte Reihe:
        addObject ( new Point(), 1, 11);
        addObject ( new Point(), 4, 11);
        addObject ( new Point(), 6, 11);
        addObject ( new Point(), 12, 11);
        addObject ( new Point(), 14, 11);
        addObject ( new Point(), 17, 11);
        // sechste Reihe:
        addObject ( new Point(), 1, 12);
        addObject ( new Point(), 2, 12);
        addObject ( new Point(), 3, 12);
        addObject ( new Point(), 4, 12);
        addObject ( new Point(), 6, 12);
        addObject ( new Point(), 7, 12);
        addObject ( new Point(), 8, 12);
        addObject ( new Point(), 10, 12);
        addObject ( new Point(), 11, 12);
        addObject ( new Point(), 12, 12);
        addObject ( new Point(), 14, 12);
        addObject ( new Point(), 15, 12);
        addObject ( new Point(), 16, 12);
        addObject ( new Point(), 17, 12);
        // siebte Reihe:
        addObject ( new Point(), 4, 13);
        addObject ( new Point(), 8, 13);
        addObject ( new Point(), 10, 13);
        addObject ( new Point(), 14, 13);
        // achte Reihe:
        addObject ( new Point(), 4, 14);
        addObject ( new Point(), 6, 14);
        addObject ( new Point(), 7, 14);
        addObject ( new Point(), 8, 14);
        addObject ( new Point(), 9, 14);
        addObject ( new Point(), 10, 14);
        addObject ( new Point(), 11, 14);
        addObject ( new Point(), 12, 14);
        addObject ( new Point(), 14, 14);
        // neunte Reihe:
        addObject ( new Point(), 4, 15);
        addObject ( new Point(), 6, 15);
        addObject ( new Point(), 12, 15);
        addObject ( new Point(), 14, 15);
        // zehnte Reihe:
        addObject ( new Point(), 0, 16);
        addObject ( new Point(), 1, 16);
        addObject ( new Point(), 2, 16);
        addObject ( new Point(), 3, 16);
        addObject ( new Point(), 4, 16);
        addObject ( new Point(), 5, 16);
        addObject ( new Point(), 6, 16);
        addObject ( new Point(), 12, 16);
        addObject ( new Point(), 13, 16);
        addObject ( new Point(), 14, 16);
        addObject ( new Point(), 15, 16);
        addObject ( new Point(), 16, 16);
        addObject ( new Point(), 17, 16);
        addObject ( new Point(), 18, 16);
        // 11te Reihe:
        addObject ( new Point(), 4, 17);
        addObject ( new Point(), 6, 17);
        addObject ( new Point(), 12, 17);
        addObject ( new Point(), 14, 17);
        // 12te Reihe:
        addObject ( new Point(), 4, 18);
        addObject ( new Point(), 6, 18);
        addObject ( new Point(), 7, 18);
        addObject ( new Point(), 8, 18);
        addObject ( new Point(), 10, 18);
        addObject ( new Point(), 11, 18);
        addObject ( new Point(), 12, 18);
        addObject ( new Point(), 14, 18);
        // 13te Reihe:
        addObject ( new Point(), 4, 19);
        addObject ( new Point(), 6, 19);
        addObject ( new Point(), 12, 19);
        addObject ( new Point(), 14, 19);
        // 14te Reihe:
        addObject ( new Point(), 1, 20);
        addObject ( new Point(), 2, 20);
        addObject ( new Point(), 3, 20);
        addObject ( new Point(), 5, 20);
        addObject ( new Point(), 4, 20);
        addObject ( new Point(), 6, 20);
        addObject ( new Point(), 7, 20);
        addObject ( new Point(), 8, 20);
        addObject ( new Point(), 10, 20);
        addObject ( new Point(), 11, 20);
        addObject ( new Point(), 12, 20);
        addObject ( new Point(), 13, 20);
        addObject ( new Point(), 14, 20);
        addObject ( new Point(), 15, 20);
        addObject ( new Point(), 16, 20);
        addObject ( new Point(), 17, 20);
        // 15te Reihe:
        addObject ( new Point(), 1, 21);
        addObject ( new Point(), 4, 21);
        addObject ( new Point(), 8, 21);
        addObject ( new Point(), 10, 21);
        addObject ( new Point(), 14, 21);
        addObject ( new Point(), 17, 21);
        // 16te Reihe:
        addObject ( new Point(), 1, 22);
        addObject ( new Point(), 2, 22);
        addObject ( new Point(), 4, 22);
        addObject ( new Point(), 5, 22);
        addObject ( new Point(), 6, 22);
        addObject ( new Point(), 7, 22);
        addObject ( new Point(), 8, 22);
        addObject ( new Point(), 9, 22);
        addObject ( new Point(), 10, 22);
        addObject ( new Point(), 11, 22);
        addObject ( new Point(), 12, 22);
        addObject ( new Point(), 13, 22);
        addObject ( new Point(), 14, 22);
        addObject ( new Point(), 16, 22);
        addObject ( new Point(), 17, 22);
        // 17te Reihe:
        addObject ( new Point(), 2, 23);
        addObject ( new Point(), 4, 23);
        addObject ( new Point(), 6, 23);
        addObject ( new Point(), 12, 23);
        addObject ( new Point(), 14, 23);
        addObject ( new Point(), 16, 23);
        // 18te Reihe:
        addObject ( new Point(), 1, 24);
        addObject ( new Point(), 2, 24);
        addObject ( new Point(), 3, 24);
        addObject ( new Point(), 4, 24);
        addObject ( new Point(), 6, 24);
        addObject ( new Point(), 7, 24);
        addObject ( new Point(), 8, 24);
        addObject ( new Point(), 10, 24);
        addObject ( new Point(), 11, 24);
        addObject ( new Point(), 12, 24);
        addObject ( new Point(), 14, 24);
        addObject ( new Point(), 15, 24);
        addObject ( new Point(), 16, 24);
        addObject ( new Point(), 17, 24);
        // 19te Reihe:
        addObject ( new Point(), 1, 25);
        addObject ( new Point(), 8, 25);
        addObject ( new Point(), 10, 25);
        addObject ( new Point(), 17, 25);
        // 20te Reihe:
        addObject ( new Point(), 1, 26);
        addObject ( new Point(), 2, 26);
        addObject ( new Point(), 3, 26);
        addObject ( new Point(), 4, 26);
        addObject ( new Point(), 5, 26);
        addObject ( new Point(), 6, 26);
        addObject ( new Point(), 7, 26);
        addObject ( new Point(), 8, 26);
        addObject ( new Point(), 9, 26);
        addObject ( new Point(), 10, 26);
        addObject ( new Point(), 11, 26);
        addObject ( new Point(), 12, 26);
        addObject ( new Point(), 13, 26);
        addObject ( new Point(), 14, 26);
        addObject ( new Point(), 15, 26);
        addObject ( new Point(), 16, 26);
        addObject ( new Point(), 17, 26);

        //PacMan headline
        addObject ( new PacManLogo(), 9,2);
    }

    public void setPunkte (int anzahl) {
        Punkte=anzahl;
    }

    public int getPunkte() {
        return Punkte;
    }
}
